//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  JScript project collection_long.jsp                                                             *****
//*****                                                                                                  *****
//*****  FUNCTIONS                                                                                       *****
//*****                                                                                                  *****
//*****  Version 3.0 / March, 2009                                                                       *****
//*****                                                                                                  *****
//*****  Author V.I. Tsanev (vip20@cam.ac.uk)                                                            *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  Function determining the optimal exposure time aiming to avoid saturation ***************************
//*****                                                                                                  *****

function optimumIT()   

{
     
//*****                                                                                                  *****
//*****  Coefficients defining increase/decrease of the cuurent integration time                         *****
//*****  whilst looking for the optimal one                                                              *****
//*****                                                                                                  *****
	     var DownCoeff =    0.95                                                       ; 
         var   UpCoeff =    1.05                                                       ; 
//*****                                                                                                  *****
//*****  Declare a few variables *****************************************************************************
//*****                                                                                                  *****
         var iline                                                                     ;
         var metext                                                                    ; 
         var i         = 0                                                             ;
         ExpTime       = MaxExpTime                                                    ;
         var ioPro                                                                     ;
         var newSpec                                                                   ;
         var CurrentMax                                                                ;
//*****                                                                                                  *****
//*****  Write header in current optimization protocol file **************************************************
//*****                                                                                                  *****
         ioPro = fso.CreateTextFile("c:\\work\\ooi\\"+BasePath+"\\"+protocol+".csv",true) ;
         ioPro.WriteLine( "Test,Selected,Current,Selected,Current" )                   ;
         ioPro.WriteLine( "scan,min,max,max,IT" )                                      ;
         ioPro.WriteLine( ",level,level,level,ms" )                                    ;
         ioPro.WriteLine( ",,,," )    
//*****                                                                                                  *****
//*****  Initialize properties of all spectra ****************************************************************
//*****                                                                                                  *****
  		 LowSpec.ChartYAxis    = "Fixed";
		 LowSpec.ChartYAxisMin = 0 ;
         LowSpec.ChartYAxisMax = MaxADCcount ;
         SpecMath.MulScalar( LowSpec,0) ; SpecMath.AddScalar( LowSpec,MinSignal)   ;

         HighSpec.ChartYAxis    = "Fixed";
		 HighSpec.ChartYAxisMin = 0 ;
         HighSpec.ChartYAxisMax = MaxADCcount ;
         SpecMath.MulScalar(HighSpec,0) ; SpecMath.AddScalar(HighSpec,MaxSignal)  ;

         MeasSpec.ChartYAxis = "Fixed" ;
         SpecMath.MulScalar(MeasSpec,0) ;
		 MeasSpec.ChartYAxisMin = 0 ;
         MeasSpec.ChartYAxisMax = MaxADCcount ;

		 MeasSpec.OverlayMode = OverlayMode.Normal        ;
         MeasSpec.AddOverlay(HighSpec) ; 
		 MeasSpec.AddOverlay( LowSpec) ;                    
		 Specbar.CurrentSpectrum = MeasSpec ;   
//*****                                                                                                  *****
//*****  Determination of the optimal exposure time **********************************************************
//*****                                                                                                  *****
	     do
	         {
//*****                                                                                                  *****
                 i++ ; iline = i + 4 ; spectrograph.Scan( MeasSpec, 1 , ExpTime ) ;
//*****                                                                                                  *****
                 CurrentMax = parseInt(MeasSpec.Max) ; metext = parseFloat(ExpTime).toFixed(2) ;
//*****                                                                                                  *****
                 ioPro.WriteLine( ""+i+","+parseInt(MinSignal)+","+CurrentMax+","+
				                  parseInt(MaxSignal)+","+metext+"" )                            ;
                 Console.WriteLine( "Test "+i+" : "+parseInt(MinSignal)+" < "+CurrentMax+" < "+
				                    parseInt(MaxSignal)+" == ET = "+ExpTime.toFixed(1)+"ms")      ;
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
                 if ( MeasSpec.Max >= MaxSignal )
		              { ExpTime = ExpTime * DownCoeff ; direction = "Down" ; }     
                 if ( MeasSpec.Max <= MinSignal )
                      { ExpTime = ExpTime *   UpCoeff ; direction =   "Up" ; }
//*****                                                                                                  *****
 	         }
//*****                                                                                                  *****
 	       while ( MeasSpec.Max >= MaxSignal || MeasSpec.Max <= MinSignal )                ;
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
	       if ( direction == "Down" )
        		ExpTime = ExpTime * DownCoeff ;
           if ( direction == "Up" )    
                ExpTime = ExpTime *   UpCoeff ; 
//*****                                                                                                  *****
  	       ExpTime = parseInt( ExpTime + 0.5)    
		                                           ;
           NumbScans = parseInt( 1000 * TotalTime / ExpTime )                            ;
           if ( NumbScans <=0 )
                { NumbScans = 1 ; } 
           var newTotalTime = parseFloat( ExpTime * NumbScans / 1000 )                   ;    
//*****                                                                                                  *****
           ioPro.WriteLine( " " )                                                        ;
           ioPro.WriteLine( " " )                                                        ;  
           ioPro.WriteLine( "" + "Performed "+ i + " tests" + "" )                       ;
           ioPro.WriteLine( " ")                                                         ;
           ioPro.WriteLine( "" + "Selected" + "")                                        ;
           ioPro.WriteLine( " ")                                                         ;
           ioPro.WriteLine( "" + "IT = " + ExpTime + " ms"+"" )                          ;
           ioPro.WriteLine( "" + "No scans = " + NumbScans + "")                         ;
           ioPro.WriteLine( "" + "Total IT = " + newTotalTime + " sec" + "")             ;
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
 
           ioPro.WriteLine("") ; ioPro.WriteLine(""+project+"") ;
		   ioPro.WriteLine(""+version+"") ; ioPro.WriteLine(""+vip20+"") ;
           ioPro.Close() ; 

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****

}

//*****                                                                                                  *****
//*****                                                                                                  *****
//*****  Function                                                                                        *****
//*****                                                                                                  *****
//*****                                                                                                  *****

function Count(j)

{

    var mm, km ; mm=j  ;
    
	if      ( mm<   10 )
			  { km= "0000"+mm+""; }
    else if ( mm<  100 )
			  { km=  "000"+mm+""; }		
    else if ( mm< 1000 )
			  { km=   "00"+mm+""; }	
    else if ( mm<10000 ) 
              { km=    "0"+mm+""; }
    return(km) ;

}

//*****                                                                                                  *****
//*****                                                                                                  *****
//*****  Function                                                                                        *****
//*****                                                                                                  *****
//*****                                                                                                  *****

function Tempo()

{

          var d1 , h , hh, m , mm , z , zz , s ;
          var c = ":"                          ;
//*****                                                                                                  *****
          d1 = new Date() ; h = d1.getHours() ; 
		   if ( h<10 ) 
              { hh = "0" + h +"" ; } 
          else
              { hh = "" + h + "" ; }
          m = d1.getMinutes() ;    
          if ( m<10 ) 
               { mm = "0" + m +"" ; } 
          else
               { mm = "" + m + "" ; }                  
          z = d1.getSeconds() ;    
          if ( z<10 ) 
               { zz = "0" + z +"" ; } 
          else
               { zz = "" + z + "" ; }                  
          s1 = hh+c+mm+c+zz ; return(s1) ;

}

//*****                                                                                                  *****
//*****                                                                                                  *****
//*****  Function                                                                                        *****
//*****                                                                                                  *****
//*****                                                                                                  *****

function Datum()
 
{
     var d, s = ""; d=new Date() ; s+=d.getDate()+"/"; s+=(d.getMonth()+1)+"/" ; s+=d.getYear() ;
	 return(s) ;

}

//*****                                                                                                  *****
//*****                                                                                                  *****
//*****  Function                                                                                        *****
//*****                                                                                                  *****
//*****                                                                                                  *****

function Quality()

{

     SpectrumQuality = "OK"
     if ( MeasSpec.Max > HighSignal ) { iHIGH++ ; SpectrumQuality = "Above MAX" ; }
     if ( MeasSpec.Max >= parseInt(MaxADCcount*NumbScans) ) { iHIGH++ ; SpectrumQuality = "Saturated" ; }
     if ( MeasSpec.Max < LowSignal ) { iLOW++  ; SpectrumQuality = "Below MIN" ; }

}


//*****                                                                                                  *****
//*****                                                                                                  *****
//*****  Function                                                                                        *****
//*****                                                                                                  *****
//*****                                                                                                  *****


        function ReportFolderStatus(fldr)
        {
          if (fso.FolderExists(fldr))  fldrEXISTS = 1;  else fldrEXISTS  = 0;
        }

//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************



