//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  JScript project collection_long.jsp                                                             *****
//*****                                                                                                  *****
//*****  MANUAL                                                                                          *****
//*****                                                                                                  *****
//*****  Version 3.0 / March, 2009                                                                       *****
//*****                                                                                                  *****
//*****  Author V.I. Tsanev (vip20@cam.ac.uk)                                                            *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** ALL LINES IN THIS FILE HAVE TO START WITH TWO BACK SLASHES                                       *****
//*****                                                                                                  *****
//***** DO NOT MODIFY THIS FILE!!!                                                                       *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  This script is designed to record sets of spectra that meet three requirements :                *****
//*****                                                                                                  *****
//*****      (a) highest possible maximum values within some accepatble gap of values ;                  *****
//*****                                                                                                  *****
//*****      (b) lack of saturation.                                                                     *****
//*****                                                                                                  *****
//*****      The above conditions mean spectra with highest possible signal-to-noise-ratio and nor       *****
//*****      satyratted. The algorithm permits to record all data sets with approximately the same       *****
//*****      common integration time (CIT) defined by the user.                                          *****
//*****                                                                                                  *****
//*****      NOTE: CIT = (individual integration time necessary for a single scan)                       *****
//*****                        times                                                                     *****
//*****                                (number of co-adds)                                               *****
//*****                                                                                                  *****
//*****  The recording process of each data set starts with optimization of the individual integration   *****
//*****      time (IIT) necessary for a single scan. IIT must provide a spectrum with high maximun value *****
//*****      but without saturation. The optimization process for each set is recorded in an individual  *****
//*****      protocol file which file name is assembled by the script (see Version history below). Then  *****
//*****      the script defines necessary number of co-adds taking into account specified by the user    *****
//*****      CIT. The script starts to record current set of spectra by using AutoFileName approach.     *****
//*****      This means that member spectra of each set are streamed in a separate folders (see Version  *****
//*****      history below). If three consecutive spectra have max values outside an acceptable gap or   *****
//*****      saturated or the number of spectra in the current set exceeds 1000 - the scipts termianates *****
//*****      the current data set and starts to record the next one.                                     *****
//*****      after collecting 1000 spectra                                                               *****
//*****                                                                                                  *****
//*****  Requires : (1) Executable beep.exe in the folder C:\work\                                       *****
//*****             (2) An non-existing base folder (subfolder of c:\wor\ooi\) where to stream           *****
//*****                 created folder and recorded spectral files. This base folder by default is       *****
//*****                 subfolder of c:\work\ooi . This subfolder has to be created during script        *****
//*****                 execution. It the foleder exist the sript will issue an error masage and         *****
//*****                 terminate.                                                                       *****
//*****                                                                                                  *****
//*****  Outputs  : (1) A comon protocol file. The project writes in this file a line for each data      *****
//*****                 set: consequent set number, start time, optimised indivudual integration time,   *****
//*****                 evaluated number of co-adds providing desired CIT, end time, and number of       *****
//*****                 recorded spectra in the current set.                                             *****
//*****             (2) One protocol file specific for each data set. The project writes in this file    *****
//*****                 a line for each spectrum: consequent spectrum number, spectrum file name, the    *****
//*****                 time when it has been recorded, min acceptable level for the max value, real     *****
//*****                 maximum value, max acceptable level for the max value, and quality of the        *****
//*****                 spectrum                                                                         *****
//*****             (3) One protocol file specific for each data set where is reported the performed     *****
//*****                 optimization.                                                                    *****
//*****             (4) A folder(s) for each data set. The spectra constituting the set are streamed     *****
//*****                 into this folder following the AutoFileName approach.                            *****
//*****             (5) A list file with full names of all recorded spectra. This file is used as input  *****
//*****                 for the JScript project correction_long.jsp                                      *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  This project includes 5 JScrips :                                                               *****
//*****                                                                                                  *****
//*****    (1) collection_long_manual.js                                                                 *****
//*****        the present file ; it may be excluded from project as it contais only comments, i.e.      *****
//*****        lines starting with two back slashes                                                      *****
//*****                                                                                                  *****
//*****    (2) collection_long_initialization.js                                                         *****
//*****        the file where user has to input parameters describing collection process                 *****
//*****                                                                                                  *****
//*****    (3) collection_long_variables.js                                                              *****
//*****        variables declaration - do not modify this file                                           *****
//*****                                                                                                  *****
//*****    (4) collection_long_action.js                                                                 *****
//*****        execution kernel - do not modify this file                                                *****
//*****                                                                                                  *****
//*****    (5) collection_long_functions.js                                                              *****
//*****        collection of functions used - do not modify this file                                    *****
//*****                                                                                                  *****
//*****  The default position of the project and all assotiated files is the folder                      *****
//*****        c:\work\scripts\collection_long\ .                                                        *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** The user has to initialize the project by modifying input in JSripts file                        *****
//*****     collection_long_initialization.js                                                            *****
//*****                                                                                                  *****
//***** ( 1) The maximum exposure time for test scans. It has to produce satutated spectrum.             *****
//*****      var MaxExpTime                                                                              *****
//*****                                                                                                  *****
//***** ( 2) Desired total integration time in seconds                                                   *****
//*****        = (optimized individual integration time) times (number of co-adds).                      *****
//*****      Optimized integration time and number of co-adds are evaluated by the script                *****
//*****      var TotalTime                                                                               *****
//*****                                                                                                  *****
//***** ( 3) A string (name) used to assemby the base folder's name and the file names of the commom     *****
//*****      protocol and the protocols specific for each recorded data sets. All these files have       *****
//*****      a "csv", i.e. there are Excel comma delimited ASCII files. The base folder nad files'       *****
//*****      positions and names are as follows:                                                         *****
//*****      c:\work\ooi\name\                                                                           *****
//*****         and                                                                                      *****
//*****      c:\work\ooi\BasePath\protocol_name.cvs                                                      *****
//*****         and                                                                                      *****
//*****      c:\work\ooi\BasePath\dataset_name1XXXXX.cvs, where XXXXX are numbers (00000, 00001,         *****
//*****      00003, etc.).                                                                               *****
//*****      The variable name is a string and the nput has to be enclosed in quotaion marks.            *****
//*****      var name                                                                                    *****
//*****                                                                                                  *****
//***** ( 4) Exnention of the recorded spectral files (including dot). Accepted options are ".std",      *****
//*****      ".spe", ".sp2" (see DOASIS manual for more options). Recommended extension is ".std" -      *****
//*****      otherwise some spectral properties cannot be saved.                                         *****
//*****      Exnention is a string and the input has to be enclosed in quotaion marks.                   *****
//*****      var commonExtension                                                                         *****
//*****                                                                                                  *****
//***** ( 5) Spectrometer type. Permitted options are "USB2000", "USB2000+" and "USB4000".               *****
//*****      Spectrometer type is a string and the input has to be enclosed in quotaion marks.           *****
//*****      var spectrometerTYPE                                                                        *****
//*****                                                                                                  *****
//***** ( 6) Spectrometer ID (serila number) - a string that has to be enclosed in quotation marks.      *****
//*****      var specID                                                                                  *****
//*****                                                                                                  *****
//***** ( 7) Experiment ID (brief description of the task). Experiment ID is a string and has to be      *****
//*****      enclosed word in quotation marks.                                                           *****
//*****      var IDexperiment                                                                            *****
//*****                                                                                                  *****
//***** ( 8) Location ID (brief description of experiment location). Location ID is a string and has     *****
//*****      to be enclosed in quotation marks.                                                          *****
//*****      var IDlocation                                                                              *****
//*****                                                                                                  *****
//***** ( 9) Author ID (e.g. "VIP20" ). Author ID is a string and has to be enclosed in quotation        *****
//*****      marks.                                                                                      *****
//*****      var IDauthor                                                                                *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  NOTES:                                                                                          *****
//*****                                                                                                  *****
//*****  #   The acceptable gap of values for the max of a single scan is defined by default as          *****
//*****      [0.95*maxADCcount,0.75*maxADCcount], where maxADCcount is the ADC digital readaout at       *****
//*****      signal saturation. When co-adding spectra aiming to improve signal-to-noise ratio           *****
//*****      gap boundaries are multiplied by the number of co-adds. Gap boudaries are indicated by      *****
//*****      coulored lines.                                                                             *****
//*****                                                                                                  *****
//*****  #   Variable name is used to assembly names of data sets, e.g. if name="v" then data set        *****
//*****      names will be "v00000", "v00001" etc.                                                       *****
//*****                                                                                                  *****
//*****  #   The spectra within each data sets are organized according AutoFileName procedure. For       *****
//*****      example if the set is "v0007" then corresponding folders will be "v00007_00000",            *****
//*****      "v00007_00100" etc. The folder "v00007_00000" keeps spetra " "v00007_00000.std",            *****
//*****      "v00007_00002.std", etc.                                                                    *****
//*****                                                                                                  *****
//*****  #   The base folder where current project streams created folders and recorded spectral files   *****
//*****      is by default sub-folder of c:\work\ooi\                                                    *****
//*****                                                                                                  *****
//*****  #   The base folder must not exists. If this sub-folder already exists, the script will         *****
//*****      terminate due to possiblity to over-write an existing data set                              *****
//*****                                                                                                  *****
//*****  #   The overall operation of the script is described in a common protocol file. Its name is     *****
//*****      defined by variable name (by default the extension is ".csv"). The file is created in       *****
//*****      the base folder. Its ful name is                                                            *****
//*****      c:\work\ooi\name\protocol_name.csv .                                                        *****
//*****      The scripts writes in the common protocol file the following information for each data set: *****
//*****      consequent number, start time, optimised indivudual integration time, evaluated number of   *****
//*****      co-adds providing desired total integration time, end tiem and number of recorded spectra.  *****
//*****                                                                                                  *****
//*****  #   The script creats in base folder two protocol files for each data sets. Both files are      *****
//*****      written in Excel comma delimited ASCII format.                                              *****
//*****                                                                                                  *****
//*****  #   The first one describes the IT optimisation process. If the current set is "v00005" its     *****
//*****      full name by default is                                                                     *****
//*****      c:\work\ooi\v\optimization_v00005.csv                                                       *****
//*****                                                                                                  *****
//*****  #   The second one describes recording process. There the script writes for the current data    *****
//*****      set: consequent number and file name of every spectrum, the time when it has been recorded, *****
//*****      min acceptable level for the max value, real maximum value and min acceptable level,        *****
//*****      quality of the spectrum and the corresponding registration conditions (individual           *****
//*****      integration time and number of co-adds). If the current set is "v00005" its its full name   *****
//*****      by default is                                                                               *****
//*****      c:\work\ooi\v\dataset_v00005.csv                                                            *****
//*****                                                                                                  *****
//*****  #   The full name of the list file is by default                                                *****
//*****      c:\work\ooi\name\list_name.txt                                                              *****
//*****                                                                                                  *****
//*****  #   User has to type his inputs only in file long_collection_with_optimum_IT_initialization.js  *****
//*****      in lines not ending with five starts (*****)                                                *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  Example of Auto File Name action :                                                              *****
//*****                                                                                                  *****
//*****           Datapath = " C:\\work\\ooi\\"                                                          *****
//*****           SpectrumPrefix = "spec"                                                                *****
//*****           SpectrumSuffix = ".std" (includind the dot ! )                                         *****
//*****           NumberOfDigits = 5                                                                     *****
//*****           FilesPerFolder = 100                                                                   *****
//*****                                                                                                  *****
//*****           Folders to be created                                                                  *****
//*****                                                                                                  *****
//*****           C:\work\ooi\spec00000\                                                                 *****
//*****           C:\work\ooi\spec00100\                                                                 *****
//*****           ......................                                                                 *****
//*****                                                                                                  *****
//*****           Files to appear in foleder C:\work\ooi\spec00000\                                      *****
//*****                                                                                                  *****
//*****           spec00000.std                                                                          *****
//*****           spec00001.std                                                                          *****
//*****           ...............                                                                        *****
//*****           spec00099.std (the last permitted, next on goes to C:\work\ooi\spec00100\              *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  Example of the content of the created list file :                                               *****
//*****                                                                                                  *****
//*****           58  - number of spectra in the list; remember count starts with zero                   *****
//*****           81  - max IT used when recording sets                                                  *****
//*****           37  - numnber co-adds in the set with min IT                                           *****   
//*****           home           - location ID                                                           *****
//*****           test           - experiment ID                                                         *****
//*****           vip20          - authors ID tells who run the project                                  *****
//*****           0 c:\work\ooi\new_long\new_long00000_00000\new_long00000_00000.std  - 1st spectrum     *****
//*****           .........                                                                              *****
//*****           58 c:\work\ooi\new_long\new_long00004_00000\new_long00004_00004.std - last spectrum    *****
//*****                                                    - intentionally empty line                    *****
//*****           JScript collection_long.jsp              - trade mark records                          *****
//*****           Version 3.0 / March 2009                 - trade mark records                          *****
//*****           Author V.I. Tsanev (vip20@cam.ac.uk)     - trade mark records                          *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  Version history :                                                                               *****
//*****                                                                                                  *****
//*****  v. 2.0  - added default fime naming of protocol files                                           *****
//*****          - project now checks if base folder exists and if YES it terminates                     *****
//*****                                                                                                  *****
//*****  v. 3.0  - added the list file                                                                   *****
//*****          - now base folder, common and sets' protopcol files and folder where are stored         *****
//*****            recorded spectra have an common part 5n the5r na0es, e.g.if this part is coco then :  *****
//*****                                                                                                  *****
//*****  base folder is             c:\work\coco\                                                        *****
//*****  common protocol file is    c:\work\ooi\coco\protocol_coco.csv                                   *****
//*****  sets' protocol files are   c:\work\ooi\coco\dataset_coco00000.csv (assume 173 spectra recorded) *****
//*****                             c:\work\ooi\coco\dataset_coco00001.csv (assume  38 spectra recorded) *****
//*****                             c:\work\ooi\coco\dataset_coco00002.csv (assume  55 spectra)          *****
//*****  optimization protocols are c:\work\ooi\coco\optimization_coco00000.csv                          *****
//*****                             c:\work\ooi\coco\optimization_coco00001.csv                          *****
//*****                             c:\work\ooi\coco\optimization_coco00002.csv                          *****
//*****  data folders are           c:\work\ooi\coco\coco00000_00000 (keeps 100 spectra)                 *****
//*****                             c:\work\ooi\coco\coco00000_00100 (keeps  73 spectra)                 *****
//*****                             c:\work\ooi\coco\coco00001_00000 (keeps  38 spectra)                 *****
//*****                             c:\work\ooi\coco\coco00002_00000 (keeps  55 spectra)                 *****
//*****  list file is               c:\work\ooi\coco\list_coco.txt                                       *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//****                                                                                                   *****
//****   Known bugs :                                                                                    *****
//****                 NONE                                                                              *****
//****                                                                                                   *****
//************************************************************************************************************
//************************************************************************************************************
